"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = Button;

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

require("./button.scss");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

/**
 * Button
 * @param   {Object} props     - React props
 * @returns    {JSX} template  - Component template
 */
function Button(_ref) {
  var active = _ref.active,
      block = _ref.block,
      caption = _ref.caption,
      children = _ref.children,
      className = _ref.className,
      disabled = _ref.disabled,
      display = _ref.display,
      id = _ref.id,
      onBlur = _ref.onBlur,
      onClick = _ref.onClick,
      onFocus = _ref.onFocus,
      onKeyUp = _ref.onKeyUp,
      size = _ref.size,
      tabIndex = _ref.tabIndex,
      type = _ref.type;
  var cssClasses = (0, _classnames.default)('button', display, size, className, {
    block: block,
    active: active
  });
  var attributes = {
    disabled: disabled,
    id: id,
    onBlur: onBlur,
    onClick: onClick,
    onFocus: onFocus,
    onKeyUp: onKeyUp,
    tabIndex: tabIndex,
    type: type
  };
  return _react.default.createElement("button", _extends({
    className: cssClasses,
    type: "button"
  }, attributes), caption || children);
}

Button.propTypes = {
  active: _propTypes.default.bool,
  block: _propTypes.default.bool,
  caption: _propTypes.default.string,
  children: _propTypes.default.node,
  className: _propTypes.default.string,
  disabled: _propTypes.default.bool,
  display: _propTypes.default.oneOf(['primary', 'link']),
  id: _propTypes.default.string,
  onBlur: _propTypes.default.func,
  onClick: _propTypes.default.func,
  onFocus: _propTypes.default.func,
  onKeyUp: _propTypes.default.func,
  size: _propTypes.default.oneOf(['large', 'small']),
  tabIndex: _propTypes.default.string,
  type: _propTypes.default.oneOf(['button', 'submit', 'reset'])
};