"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

require("./dropdown.scss");

var _button = _interopRequireDefault(require("../button/button"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var optionHeight = 48;
/**
 * Dropdown
 * @param   {Object} props     - React props
 * @returns    {JSX} template  - Component template
 */

var Dropdown =
/*#__PURE__*/
function (_Component) {
  _inherits(Dropdown, _Component);

  /**
   * Constructor
   * @param {Object} props - React props
   */
  function Dropdown(props) {
    var _this;

    _classCallCheck(this, Dropdown);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Dropdown).call(this, props));
    _this.options = [];
    _this.state = {
      isOpen: Boolean(props.isOpen)
    };
    _this.close = _this.close.bind(_assertThisInitialized(_this));
    _this.select = _this.select.bind(_assertThisInitialized(_this));
    _this.setFocusedOption = _this.setFocusedOption.bind(_assertThisInitialized(_this));
    _this.toggleOpen = _this.toggleOpen.bind(_assertThisInitialized(_this));
    _this.handleSelectBlur = _this.handleSelectBlur.bind(_assertThisInitialized(_this));
    _this.handleSelectKeyDown = _this.handleSelectKeyDown.bind(_assertThisInitialized(_this));
    _this.handleSelectKeyUp = _this.handleSelectKeyUp.bind(_assertThisInitialized(_this));
    _this.handleTriggerKeyUp = _this.handleTriggerKeyUp.bind(_assertThisInitialized(_this));
    _this.handleOptionFocused = _this.handleOptionFocused.bind(_assertThisInitialized(_this));
    _this.handleOptionSelected = _this.handleOptionSelected.bind(_assertThisInitialized(_this));
    _this.handleOptionsMouseDown = _this.handleOptionsMouseDown.bind(_assertThisInitialized(_this));
    return _this;
  }
  /**
   * When component unmounts remove click outside listener
   */


  _createClass(Dropdown, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      document.removeEventListener('click', this.close);
    }
    /**
     * Sets focus and scrolls container to an option element
     * @param {number} index - Index of the element to set focused
     */

  }, {
    key: "setFocusedOption",
    value: function setFocusedOption(index) {
      var _this$props = this.props,
          size = _this$props.size,
          options = _this$props.options;
      var elem = this.options[index]; // istanbul ignore next
      // When limited size and capped scroll to visible is needed

      if (size && options && size < options.length) {
        if (elem.offsetTop + elem.offsetHeight > this.list.offsetHeight) {
          this.list.scrollTop = elem.offsetTop + (elem.offsetHeight - this.list.offsetHeight);
        } else if (elem.offsetTop < this.list.scrollTop) {
          this.list.scrollTop = elem.offsetTop;
        }
      }

      this.setState({
        optionFocused: index
      });
    }
    /**
     * Selects an option and closes
     * @param {string} value - Selected value
     */

  }, {
    key: "select",
    value: function select(value) {
      var onSelect = this.props.onSelect;

      if (onSelect) {
        onSelect(value);
      }

      this.close();
    }
    /**
     * Closes the dropdown element
     */

  }, {
    key: "close",
    value: function close() {
      this.setState({
        isOpen: false,
        optionFocused: null
      });
      document.removeEventListener('click', this.close);
    }
    /**
     * Opens or closes the dropdown element
     */

  }, {
    key: "toggleOpen",
    value: function toggleOpen() {
      var isOpen = this.state.isOpen;
      this.setState({
        isOpen: !isOpen,
        optionFocused: null
      });

      if (!isOpen) {
        document.addEventListener('click', this.close);
      }
    }
    /**
     * When trigger has enter or space pressed open dropdown
     * @param {object} event - DOM event object
     */

  }, {
    key: "handleTriggerKeyUp",
    value: function handleTriggerKeyUp(event) {
      var code = event.keyCode || event.which;

      if (code === 13 || code === 32) {
        event.preventDefault();
        this.toggleOpen();
      }
    }
    /**
     * Close dropdown on blur
     */

  }, {
    key: "handleSelectBlur",
    value: function handleSelectBlur() {
      this.close();
    }
    /**
     * Avoid blur to be fired before click an option
     * @param {object} event - DOM event object
     */

  }, {
    key: "handleOptionsMouseDown",
    value: function handleOptionsMouseDown(event) {
      event.preventDefault();
    }
    /**
     * Disable scroll on page
     * @param {object} event - DOM event object
     */

  }, {
    key: "handleSelectKeyDown",
    value: function handleSelectKeyDown(event) {
      // istanbul ignore next
      var code = event.keyCode || event.which;

      if (code === 38 || code === 40 || code === 13 || code === 32) {
        event.preventDefault();
        event.stopPropagation();
      }
    }
    /**
     * Handle keys for
     *  - cycling through options and select one
     *  - close when escape
     *  - select on enter
     * @param {object} event - DOM event object
     */

  }, {
    key: "handleSelectKeyUp",
    value: function handleSelectKeyUp(event) {
      var options = this.props.options;
      var _this$state = this.state,
          isOpen = _this$state.isOpen,
          optionFocused = _this$state.optionFocused; // istanbul ignore next

      var code = event.keyCode || event.which;

      switch (code) {
        case 38:
          // Up arrow
          event.preventDefault();

          if (optionFocused > 0) {
            this.setFocusedOption(optionFocused - 1);
          }

          break;

        case 40:
          // Down arrow
          event.preventDefault();

          if (optionFocused === null) {
            this.setFocusedOption(optionFocused - 0);
          } else if (optionFocused < options.length - 1) {
            this.setFocusedOption(optionFocused + 1);
          }

          break;

        case 13: // Enter

        case 32:
          // Space
          event.preventDefault();

          if (optionFocused !== null && isOpen) {
            this.select(options[optionFocused]);
          }

          break;

        case 27:
          // Esc
          event.preventDefault();
          this.close();
          break;

        default:
          break;
      }
    }
    /**
     * Handler when an option is focused by:
     *  - hover
     *  - focus
     * @param {string} index - Focused option index
     * @returns {function}   - Event handler function
     */

  }, {
    key: "handleOptionFocused",
    value: function handleOptionFocused(index) {
      var _this2 = this;

      return function () {
        _this2.setFocusedOption(index);
      };
    }
    /**
     * Handler when an option is selected by:
     *  - click
     *  - press enter or space
     * @param {string} value - Selected option value
     * @returns {function}   - Event handler function
     */

  }, {
    key: "handleOptionSelected",
    value: function handleOptionSelected(value) {
      var _this3 = this;

      return function (event) {
        var code = event.key || event.keyCode || event.which;

        if (code === 13 || code === 32 || !code) {
          _this3.select(value);
        }
      };
    }
    /**
     * Render method
     * @returns {JSX} - Component template
     */

  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var _this$state2 = this.state,
          isOpen = _this$state2.isOpen,
          optionFocused = _this$state2.optionFocused;
      var _this$props2 = this.props,
          caption = _this$props2.caption,
          children = _this$props2.children,
          options = _this$props2.options,
          size = _this$props2.size;
      var listStyle = {};
      var trigger = (0, _react.cloneElement)(children || _react.default.createElement(_button.default, {
        arrow: isOpen ? 'up' : 'down',
        caption: caption
      }), _objectSpread({}, children ? children.props : {}, {
        className: (0, _classnames.default)('trigger', children ? children.props.className : ''),
        onClick: this.toggleOpen,
        onKeyUp: this.handleTriggerKeyUp,
        tabIndex: '0'
      }));

      if (size && options && size < options.length) {
        listStyle.maxHeight = "".concat(optionHeight * (size + 0.5), "px");
        listStyle.overflowY = 'scroll';
      }

      return _react.default.createElement("div", {
        className: (0, _classnames.default)('dropdown', {
          'is-open': isOpen
        }),
        onBlur: this.handleSelectBlur,
        onKeyDown: this.handleSelectKeyDown,
        onKeyUp: this.handleSelectKeyUp,
        tabIndex: "-1"
      }, trigger, isOpen && _react.default.createElement("ul", {
        className: "options",
        onMouseDown: this.handleOptionsMouseDown,
        ref: function ref(_ref2) {
          _this4.list = _ref2;
        },
        role: "listbox",
        style: listStyle
      }, options && options.map(function (option, index) {
        return _react.default.createElement("li", {
          className: (0, _classnames.default)('option', {
            focus: optionFocused === index
          }),
          key: index,
          onClick: _this4.handleOptionSelected(option.value || option),
          onFocus: _this4.handleOptionFocused(index),
          onKeyUp: _this4.handleOptionSelected(option.value || option),
          onMouseOver: _this4.handleOptionFocused(index),
          ref: function ref(_ref) {
            _this4.options[index] = _ref;
          },
          role: "option",
          tabIndex: "-1"
        }, option.label || option);
      })));
    }
  }]);

  return Dropdown;
}(_react.Component);

exports.default = Dropdown;
Dropdown.propTypes = {
  caption: _propTypes.default.string,
  children: _propTypes.default.element,
  isOpen: _propTypes.default.bool,
  onSelect: _propTypes.default.func,
  options: _propTypes.default.arrayOf(_propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.shape({
    value: _propTypes.default.string,
    label: _propTypes.default.string
  })])),
  size: _propTypes.default.number
};