"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

require("./field.scss");

var _select = _interopRequireDefault(require("./select"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

/**
 * Field
 * Wraps the label and error of any form field
 * @param {Object} props    - React props
 * @returns  {JSX} template - Component template
 */
var Field =
/*#__PURE__*/
function (_Component) {
  _inherits(Field, _Component);

  /**
   * Constructor
   * @param {Object} props - React props
   */
  function Field(props) {
    var _this;

    _classCallCheck(this, Field);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Field).call(this, props));
    _this.state = {
      errorMessage: '',
      invalid: false
    };
    _this.handleChange = _this.handleChange.bind(_assertThisInitialized(_this));
    _this.handleInvalid = _this.handleInvalid.bind(_assertThisInitialized(_this));
    return _this;
  }
  /**
   * Component mounted on DOM
   */


  _createClass(Field, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var validate = this.props.validate;
      var elem = this.formElem;

      if (validate && elem.checkValidity) {
        elem.checkValidity();
      }
    }
    /**
     * When Change response with just value
     * @param {object} event - DOM event object
     */

  }, {
    key: "handleChange",
    value: function handleChange(event) {
      var _this$props = this.props,
          validate = _this$props.validate,
          onChange = _this$props.onChange;
      var invalid = this.state.invalid;

      if (invalid || validate) {
        this.validate(event.target);
      } // istanbul ignore else


      if (onChange) {
        onChange(event.target.value);
      }
    }
    /**
     * When Invalid value stop default browser validation popups
     * and do custom field validation
     * @param {object} event - DOM event object
     */

  }, {
    key: "handleInvalid",
    value: function handleInvalid(event) {
      event.preventDefault();
      this.setState({
        invalid: true
      });
      this.validate(event.target);
    }
    /**
     * Analyze validity and set error message
     * @param {object} elem - Form element to be validated
     */

  }, {
    key: "validate",
    value: function validate(elem) {
      var _this$props2 = this.props,
          errorMessages = _this$props2.errorMessages,
          type = _this$props2.type;

      if (elem.validity && !elem.validity.valid) {
        if (elem.validity.valueMissing) {
          this.setState({
            errorMessage: errorMessages.valueMissing || 'This is a required field.',
            invalid: true
          });
        } else if (elem.validity.typeMismatch) {
          this.setState({
            errorMessage: errorMessages.typeMismatch || "This value is not an ".concat(type, "."),
            invalid: true
          });
        } else {
          this.setState({
            errorMessage: errorMessages.patternMismatch || 'This value is invalid.',
            invalid: true
          });
        }
      } else {
        this.setState({
          errorMessage: '',
          invalid: false
        });
      }
    }
    /**
     * Render method
     * @returns {JSX} - Component template
     */

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props3 = this.props,
          className = _this$props3.className,
          component = _this$props3.component,
          disabled = _this$props3.disabled,
          id = _this$props3.id,
          inline = _this$props3.inline,
          label = _this$props3.label,
          readOnly = _this$props3.readOnly,
          required = _this$props3.required,
          errorMessages = _this$props3.errorMessages,
          multiLine = _this$props3.multiLine,
          resize = _this$props3.resize,
          validate = _this$props3.validate,
          other = _objectWithoutProperties(_this$props3, ["className", "component", "disabled", "id", "inline", "label", "readOnly", "required", "errorMessages", "multiLine", "resize", "validate"]);

      var _this$state = this.state,
          errorMessage = _this$state.errorMessage,
          invalid = _this$state.invalid;
      var FormElement;
      var Element = inline ? 'span' : 'div';
      var fieldCSS = (0, _classnames.default)('field', {
        disabled: disabled,
        inline: inline,
        invalid: invalid,
        readonly: readOnly
      }, className);
      var ariaAttrs = !invalid ? {} : {
        'aria-invalid': invalid,
        'aria-describedby': "".concat(id, "-error")
      }; // eslint-disable-next-line no-nested-ternary

      var elementStyle = {
        resize: !resize ? 'none' : resize === true ? 'both' : resize
      };
      FormElement = component === 'select' ? _select.default : component;

      if (multiLine && component === 'input') {
        FormElement = 'textarea';
      }

      return _react.default.createElement(Element, {
        className: fieldCSS
      }, label && _react.default.createElement("label", {
        className: "field-label",
        htmlFor: id
      }, label, required && _react.default.createElement("span", {
        "aria-label": "Required",
        className: "icon icon-required",
        title: "Required"
      })), _react.default.createElement(FormElement, _extends({}, other, ariaAttrs, {
        className: "field-element",
        disabled: disabled,
        id: id,
        onChange: this.handleChange,
        onInvalid: this.handleInvalid,
        readOnly: readOnly,
        ref: function ref(_ref) {
          _this2.formElem = _ref;
        },
        required: required,
        style: elementStyle
      })), errorMessage && _react.default.createElement(Element, {
        className: "field-error",
        id: "".concat(id, "-error")
      }, errorMessage));
    }
  }]);

  return Field;
}(_react.Component);

exports.default = Field;
Field.propTypes = {
  autoComplete: _propTypes.default.bool,
  autoFocus: _propTypes.default.bool,
  className: _propTypes.default.string,
  cols: _propTypes.default.number,
  component: _propTypes.default.oneOf(['input', 'select', 'textarea']),
  defaultValue: _propTypes.default.string,
  disabled: _propTypes.default.bool,
  errorMessages: _propTypes.default.shape({
    patternMismatch: _propTypes.default.string,
    typeMismatch: _propTypes.default.string,
    valueMissing: _propTypes.default.string
  }),
  form: _propTypes.default.string,
  formaction: _propTypes.default.string,
  formenctype: _propTypes.default.string,
  formmethod: _propTypes.default.oneOf(['get', 'post']),
  formnovalidate: _propTypes.default.bool,
  formtarget: _propTypes.default.string,
  id: _propTypes.default.string,
  inline: _propTypes.default.bool,
  label: _propTypes.default.string,
  max: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string]),
  maxLength: _propTypes.default.number,
  min: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string]),
  minLength: _propTypes.default.number,
  multiLine: _propTypes.default.bool,
  name: _propTypes.default.string,
  onBlur: _propTypes.default.func,
  onChange: _propTypes.default.func,
  onFocus: _propTypes.default.func,
  onInvalid: _propTypes.default.func,
  pattern: _propTypes.default.string,
  placeholder: _propTypes.default.string,
  readOnly: _propTypes.default.bool,
  required: _propTypes.default.bool,
  resize: _propTypes.default.oneOfType([_propTypes.default.bool, _propTypes.default.oneOf(['none', 'both', 'horizontal', 'vertical', 'inherit'])]),
  rows: _propTypes.default.number,
  size: _propTypes.default.number,
  spellCheck: _propTypes.default.bool,
  step: _propTypes.default.number,
  tabIndex: _propTypes.default.number,
  type: _propTypes.default.oneOf(['text', 'email', 'number', 'password', 'hidden', 'tel', 'url', 'color', 'search', 'range', 'date', 'datetime-local', 'week', 'month']),
  validate: _propTypes.default.bool,
  wrap: _propTypes.default.oneOf(['hard', 'soft'])
};
Field.defaultProps = {
  component: 'input',
  errorMessages: {},
  type: 'text'
};