"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

require("./select.scss");

var _dropdown = _interopRequireDefault(require("../dropdown/dropdown"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

/**
 * Select
 * Form controller with custom styles
 */
var Select =
/*#__PURE__*/
function (_Component) {
  _inherits(Select, _Component);

  /**
   * Constructor
   * @param {Object} props - React props
   */
  function Select(props) {
    var _this;

    _classCallCheck(this, Select);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Select).call(this, props));
    _this.state = {
      value: props.defaultValue
    };
    _this.handleDropdown = _this.handleDropdown.bind(_assertThisInitialized(_this));
    _this.handleBlur = _this.handleBlur.bind(_assertThisInitialized(_this));
    _this.handleFocus = _this.handleFocus.bind(_assertThisInitialized(_this));
    _this.handleSelect = _this.handleSelect.bind(_assertThisInitialized(_this));
    return _this;
  }
  /**
   * Forward checkValidity to the select element
   */


  _createClass(Select, [{
    key: "checkValidity",
    value: function checkValidity() {
      this.select.checkValidity();
    }
    /**
     * When blurred remove class for focus styles
     */

  }, {
    key: "handleBlur",
    value: function handleBlur() {
      this.setState({
        focus: false
      });
    }
    /**
     * When focused set class for focus styles
     */

  }, {
    key: "handleFocus",
    value: function handleFocus() {
      this.setState({
        focus: true
      });
    }
    /**
     * When dropdown change update select value
     * @param {string} value - Selected dropdown value
     */

  }, {
    key: "handleDropdown",
    value: function handleDropdown(value) {
      var onChange = this.props.onChange; // istanbul ignore else

      if (value !== this.select.value) {
        this.setState({
          value: value
        });
        this.select.value = value;
        var event = new window.Event('change', {
          bubbles: true
        });
        this.select.dispatchEvent(event);

        if (onChange) {
          onChange(event);
        }
      }
    }
    /**
     * When dropdown change update select value
     * @param {object} event - DOM event object
     */

  }, {
    key: "handleSelect",
    value: function handleSelect(event) {
      var onChange = this.props.onChange;
      this.setState({
        value: event.target.value
      });

      if (onChange) {
        onChange(event);
      }
    }
    /**
     * Render method
     * @returns {JSX} - Component template
     */

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var dropdownOptions = [];

      var _this$props = this.props,
          className = _this$props.className,
          onInvalid = _this$props.onInvalid,
          options = _this$props.options,
          placeholder = _this$props.placeholder,
          other = _objectWithoutProperties(_this$props, ["className", "onInvalid", "options", "placeholder"]);

      var _this$state = this.state,
          focus = _this$state.focus,
          value = _this$state.value;
      var selectCSS = (0, _classnames.default)('selected-option', className, {
        focus: focus
      });

      if (placeholder) {
        dropdownOptions = dropdownOptions.concat(options && options[0] && options[0].value ? {
          value: '',
          label: placeholder
        } : placeholder);
      }

      if (options) {
        dropdownOptions = dropdownOptions.concat(options);
      }

      return _react.default.createElement("div", {
        className: "select"
      }, _react.default.createElement(_dropdown.default, {
        "aria-hidden": "true",
        onSelect: this.handleDropdown,
        options: dropdownOptions
      }, _react.default.createElement("div", {
        className: selectCSS
      }, value || placeholder || "\xA0")), _react.default.createElement("select", _extends({}, other, {
        onBlur: this.handleBlur,
        onChange: this.handleSelect,
        onFocus: this.handleFocus,
        onInvalid: onInvalid,
        ref: function ref(_ref) {
          _this2.select = _ref;
        },
        tabIndex: "-1"
      }), placeholder && _react.default.createElement("option", {
        value: ""
      }, placeholder), options && options.map(function (option, id) {
        return _react.default.createElement("option", {
          key: id,
          value: option.value || option
        }, option.label || option);
      })));
    }
  }]);

  return Select;
}(_react.Component);

exports.default = Select;
Select.propTypes = {
  className: _propTypes.default.string,
  defaultValue: _propTypes.default.string,
  onChange: _propTypes.default.func,
  onInvalid: _propTypes.default.func,
  options: _propTypes.default.arrayOf(_propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.shape({
    value: _propTypes.default.string,
    label: _propTypes.default.string
  })])),
  placeholder: _propTypes.default.string
};